;--------------------------------------
; ETS 16 CLOCK FROM 64 CLOCK
; OSEF OUCEK 1999
; -MAIL: JOSEF.SOUCEK@SPT.CZ
;--------------------------------------

              .INCLUDE "ACEHEAD.S"

              *= ACEPPDDRESS

              JMP MAIN
              .BYTE ACE1,ACE2,ACE3
              .BYTE 64,0                ;** STACK,RESERVED

MAIN          = *
              LDA #<INFOSG
              LDY #>INFOSG
              STA ZP+0
              STY ZP+1
              LDA #<INFOSGND-INFOSG
              LDY #>INFOSGND-INFOSG
              LDX #STDOUT
              JSR WRITE

              JSR READ_TIME
              JSR CONVERT_TIME
              LDA #<ACE_DATE_BUFF
              LDY #>ACE_DATE_BUFF
              JSR ACEIMEETATE
              RTS

;--------------------------------------
CLOCKPORT  = $DE5F
CLOCKRESET = $DEFB 

READ_TIME     = *
              SEI
              LDA #$02
              STA CLOCKRESET  ;ENABLE CLOCK CHIP

              LDA #%10111111  ;CLOCK BURST READ COMMAND
              JSR SENDBYTE

              LDY #$00
INPUT         JSR READBYTE
              STA IDE_DATE_BUFF,Y
              INY
              CPY #$08        ;NO. OF BYTES
              BNE INPUT

              LDA #$00        ;DISABLE CLOCK CHIP
              STA CLOCKRESET

              CLI
              RTS
;--------------------------------------

SENDBYTE      STA CLOCKPORT ; BIT 0
              LSR A
              STA CLOCKPORT ; BIT 1
              LSR A
              STA CLOCKPORT ; BIT 2
              LSR A
              STA CLOCKPORT ; BIT 3
              LSR A
              STA CLOCKPORT ; BIT 4
              LSR A
              STA CLOCKPORT ; BIT 5
              LSR A
              STA CLOCKPORT ; BIT 6
              LSR A
              STA CLOCKPORT ; BIT 7
              RTS

READBYTE      LDA #$00
              STA ZP
              LDA CLOCKPORT  ; BIT 0
              LSR A
              ROR ZP
              LDA CLOCKPORT  ; BIT 1
              LSR A
              ROR ZP
              LDA CLOCKPORT  ; BIT 2
              LSR A
              ROR ZP
              LDA CLOCKPORT  ; BIT 3
              LSR A
              ROR ZP
              LDA CLOCKPORT  ; BIT 4
              LSR A
              ROR ZP
              LDA CLOCKPORT  ; BIT 5
              LSR A
              ROR ZP
              LDA CLOCKPORT  ; BIT 6
              LSR A
              ROR ZP
              LDA CLOCKPORT  ; BIT 7
              LSR A
              ROR ZP
              LDA ZP
              RTS    
;-----------------------------------------

CONVERT_TIME  = *
              LDA IDE_DATE_BUFF    ;SS
              STA ACE_DATE_BUFF+6
              LDA IDE_DATE_BUFF+1  ;MM
              STA ACE_DATE_BUFF+5
              LDA IDE_DATE_BUFF+2  ;HH
              STA ACE_DATE_BUFF+4
              LDA IDE_DATE_BUFF+3  ;
              STA ACE_DATE_BUFF+3
              LDA IDE_DATE_BUFF+4  ;
              STA ACE_DATE_BUFF+2
              LDA IDE_DATE_BUFF+6  ;
              STA ACE_DATE_BUFF+1
              CMP #$80
              BCC C_21
              LDA #$19             ;YEARS 1980-$1999
              STA ACE_DATE_BUFF
              RTS
C_21          LDA #$20             ;YEARS $2000-$2079
              STA ACE_DATE_BUFF
              RTS

;--------------------------------------
; ATE AND TIME IN 
;--------------------------------------
ACE_DATE_BUFF = *
;              .BYTE $19,$99,$06,$20,$17,$10,$00,$00,$07,$99,$99,$99
              *= *+1    ; 
              *= *+1    ;
              *= *+1    ;
              *= *+1    ;
              *= *+1    ;HH
              *= *+1    ;MM
              *= *+1    ;SS
               .BYTE $00,$07,$99,$99,$99
;              *= *+1    ;TT - HUNDERTS OF SECOND
;              *= *+1    ;TW - DAY OF THE WEEK 0=SUNDAY 7=UNKNOWN
;              *= *+1    ; - OFFSET FROM  $80-NEGATIVE 99=UNKNOWN
;              *= *+1    ;GG - OFFSET IN MINUTES
;              *= *+1    ;AA - TIME-ZONE ACCURANCY 99=UNKNOWN
;--------------------------------------
IDE_DATE_BUFF  = *
               * = *+1   ;SS
               * = *+1   ;MM
               * = *+1   ;HH
               * = *+1   ;
               * = *+1   ;
               * = *+1   ;
               * = *+1   ; ($00-$99)
               * = *+1   ;
;--------------------------------------
INFOSG        = *
               .BYTE ""+128
               .TEXT "    "
               .BYTE ""+128,""+128,""+128
               .TEXT "' -  ..."
               .BYTE CHR
INFOSGND     = *
